Index: Makefile.am
===================================================================
--- Makefile.am	(revision 201)
+++ Makefile.am	(revision 186)
@@ -48,20 +48,6 @@
 	dijkstrabox.h \
 	dijkstrabox.cc \
-	file_import_dialog.h \
-	file_import_dialog.cc \
-	map_value.h \
-	map_value.cc \
-	map_value_map.h \
-	map_value_map.cc \
-	save_details_widget.h \
-	save_details_widget.cc \
-	save_details_dialog.h \
-	save_details_dialog.cc \
-	io_helper.h \
-	io_helper.cc \
 	background_chooser_dialog.h \
-	background_chooser_dialog.cc \
-	eps_win.h \
-	eps_win.cc
+	background_chooser_dialog.cc
 
 glemon_CXXFLAGS = $(GTK_CFLAGS) $(LEMON_CFLAGS)
@@ -76,6 +62,5 @@
 	icons/editnode.png \
 	icons/move.png \
-	icons/newmap.png \
-	icons/eps.png
+	icons/newmap.png
 
 VARIABLES = \
@@ -86,7 +71,6 @@
 	gui_icons_editnode $(srcdir)/icons/editnode.png \
 	gui_icons_move $(srcdir)/icons/move.png \
-	gui_icons_newmap $(srcdir)/icons/newmap.png \
-	gui_icons_eps $(srcdir)/icons/eps.png
-	
+	gui_icons_newmap $(srcdir)/icons/newmap.png
+
 guipixbufs.h: $(IMAGES)
 	gdk-pixbuf-csource \
Index: algobox.cc
===================================================================
--- algobox.cc	(revision 201)
+++ algobox.cc	(revision 174)
@@ -18,6 +18,4 @@
 
 #include <algobox.h>
-#include <mapstorage.h>
-#include <mapselector.h>
 
 enum {N_DEMO1, N_DEMO2, NODE_INPUT_NUM}; // input IDs for nodes;
@@ -83,25 +81,21 @@
 {
   mapstorage=ms;
-  std::vector<std::string> n_nml;
-  std::vector<std::string> s_nml;
-  std::vector<std::string> n_eml;
-  std::vector<std::string> s_eml;
+  std::vector<std::string> nml;
+  std::vector<std::string> eml;
   if(mapstorage!=NULL)
     {
       mapstorage->signal_node_map_ch().connect(sigc::mem_fun(*this, &AlgoBox::nodemaplist_changed));
       mapstorage->signal_edge_map_ch().connect(sigc::mem_fun(*this, &AlgoBox::edgemaplist_changed));
-      n_nml=mapstorage->getNodeMapList(NUM);
-      s_nml=mapstorage->getNodeMapList(STR);
-      n_eml=mapstorage->getEdgeMapList(NUM);
-      s_eml=mapstorage->getEdgeMapList(STR);
+      nml=mapstorage->getNodeMapList();
+      eml=mapstorage->getEdgeMapList();
     }
   for(int i=0;i<(int)nodemapcbts.size();i++)
     {
-      (nodemapcbts[i])->update_list(n_nml, s_nml);
+      (nodemapcbts[i])->update_list(nml);
       //update_cbt(nml, *(nodemapcbts[i]));
     }
   for(int i=0;i<(int)edgemapcbts.size();i++)
     {
-      (edgemapcbts[i])->update_list(n_eml, s_eml);
+      (edgemapcbts[i])->update_list(eml);
       //update_cbt(eml, *(edgemapcbts[i]));
     }
@@ -109,17 +103,17 @@
 }
 
-void AlgoBox::nodemaplist_changed(std::string newmap, MapValue::Type type)
+void AlgoBox::nodemaplist_changed(std::string newmap)
 {
   for(int i=0;i<(int)nodemapcbts.size();i++)
     {
-      (nodemapcbts[i])->append_text(newmap, type);
-    }
-}
-
-void AlgoBox::edgemaplist_changed(std::string newmap, MapValue::Type type)
+      (nodemapcbts[i])->append_text(newmap);
+    }
+}
+
+void AlgoBox::edgemaplist_changed(std::string newmap)
 {
   for(int i=0;i<(int)edgemapcbts.size();i++)
     {
-      (edgemapcbts[i])->append_text(newmap, type);
+      (edgemapcbts[i])->append_text(newmap);
     }
 }
@@ -165,9 +159,9 @@
 }
 
-void AlgoBox::addMapSelector(std::string inputname, bool itisedge, MapType type)
+void AlgoBox::addMapSelector(std::string inputname, bool itisedge)
 {
   std::vector<std::string> empty_vector;
 
-  MapSelector * msp=new MapSelector(empty_vector,empty_vector,"",inputname,itisedge, false, type);
+  MapSelector * msp=new MapSelector(empty_vector,"",inputname,itisedge, false);
 
   if(itisedge)
Index: algobox.h
===================================================================
--- algobox.h	(revision 201)
+++ algobox.h	(revision 174)
@@ -20,11 +20,11 @@
 #define ALGOBOX_H
 
-class MapStorage;
-class MapSelector;
+class AlgoBox;
 
 #include <all_include.h>
+#include <mapstorage.h>
+#include <mapselector.h>
 #include <libgnomecanvasmm.h>
 #include <libgnomecanvasmm/polygon.h>
-#include "map_value.h"
 
 ///Ancestor class of algorithm graphical interface classes.
@@ -140,5 +140,5 @@
   ///a signal is emitted by it. This signal is connected to this function, so \ref MapSelector s
   ///in \ref nodemapcbts can be notified, and those can registrate the new map. (\ref MapSelector::append_text)
-  void nodemaplist_changed(std::string, MapValue::Type);
+  void nodemaplist_changed(std::string);
 
   ///Interface, through which \ref AlgoBox can be notified about edgemap addition.
@@ -147,5 +147,5 @@
   ///a signal is emitted by it. This signal is connected to this function, so \ref MapSelector s
   ///in \ref edgemapcbts can be notified, and those can registrate the new map. (\ref MapSelector::append_text)
-  void edgemaplist_changed(std::string, MapValue::Type);
+  void edgemaplist_changed(std::string);
 
   ///Aid function to provide data for a given entry.
@@ -185,5 +185,5 @@
   ///\param label label to show in \ref MapSelector
   ///\param itisedge whether edge or nodemaps stored in \ref MapSelector
-  void addMapSelector(std::string label, bool itisedge, MapType type = ALL);
+  void addMapSelector(std::string label, bool itisedge);
 };
 #endif //ALGOBOX_H
Index: algowin.cc
===================================================================
--- algowin.cc	(revision 194)
+++ algowin.cc	(revision 174)
@@ -18,5 +18,4 @@
 
 #include <algowin.h>
-#include <algobox.h>
 #include <kruskalbox.h>
 #include <dijkstrabox.h>
Index: algowin.h
===================================================================
--- algowin.h	(revision 194)
+++ algowin.h	(revision 174)
@@ -20,9 +20,12 @@
 #define ALGOWIN_H
 
+class AlgoWin;
+
 #include <all_include.h>
+//#include <mapstorage.h>
+#include <algobox.h>
 #include <libgnomecanvasmm.h>
 #include <libgnomecanvasmm/polygon.h>
 
-class AlgoBox;
 class MapStorage;
 
Index: all_include.h
===================================================================
--- all_include.h	(revision 201)
+++ all_include.h	(revision 174)
@@ -35,5 +35,4 @@
 enum {E_WIDTH, E_COLOR, E_TEXT, EDGE_PROPERTY_NUM}; // edge properties;
 enum {N_RADIUS, N_COLOR, N_TEXT, NODE_PROPERTY_NUM}; // node properties;
-enum {N_MAPS, E_MAPS, ARROWS, PAR, EPS_PROPERTY_NUM}; // eps properties;
 enum {MOVE, CREATE_NODE, CREATE_EDGE, ERASER, MAP_EDIT, TOOL_NUM}; // tools;
 #define RANGE 3
@@ -66,10 +65,3 @@
 const std::string prog_name = "LEMON Graph Editor";
 
-enum MapType
-{
-  NUM  = 1 << 0,
-  STR  = 1 << 1,
-  ALL  = (1 << 0) | (1 << 1)
-};
-
 #endif // ALL_INCLUDE_H
Index: background_chooser_dialog.cc
===================================================================
--- background_chooser_dialog.cc	(revision 194)
+++ background_chooser_dialog.cc	(revision 184)
@@ -1,5 +1,5 @@
-#include <background_chooser_dialog.h>
+#include "background_chooser_dialog.h"
 #include <gtkmm/stock.h>
-#include <mapstorage.h>
+#include "mapstorage.h"
 
 BackgroundChooserDialog::BackgroundChooserDialog(MapStorage* ms) :
Index: configure.ac
===================================================================
--- configure.ac	(revision 201)
+++ configure.ac	(revision 183)
@@ -27,11 +27,31 @@
 PKG_CHECK_MODULES([GTK], [libgnomecanvasmm-2.6 >= 2.6.0 gtkmm-2.4 >= 2.6])
 
-AC_ARG_WITH([lemon],
-AS_HELP_STRING([--with-lemon@<:@=PREFIX@:>@], [search for LEMON under PREFIX]), [], [with_lemon=no])
-if test x"$with_lemon" != x"no"; then
-  export PKG_CONFIG_PATH="$with_lemon/lib/pkgconfig/:$PKG_CONFIG_PATH"
+AC_ARG_WITH([lemon-prefix],
+AS_HELP_STRING([--with-lemon-prefix@<:@=PREFIX@:>@], [search for LEMON under PREFIX]), [], [with_lemon_prefix=no])
+if test x"$with_lemon_prefix" != x"no"; then
+  export PKG_CONFIG_PATH="$with_lemon_prefix/lib/pkgconfig/:$PKG_CONFIG_PATH"
 fi
 
-PKG_CHECK_MODULES([LEMON], [lemon >= 0.6.90])
+PKG_CHECK_MODULES([LEMON_0_5], [lemon >= 0.5],
+  [lemon_0_5_found=yes], [
+    AC_MSG_RESULT([no])
+    lemon_0_5_found=no])
+PKG_CHECK_MODULES([LEMON_SVNHEAD], [lemon = svnhead],
+  [lemon_svn_head_found=yes], [
+    AC_MSG_RESULT([no])
+    lemon_svn_head_found=no])
+if test x"$lemon_0_5_found" = x"no" -a x"$lemon_svn_head_found" = x"no"; then
+  AC_MSG_ERROR([LEMON not found.])
+else
+  if test x"$lemon_svn_head_found" = x"yes"; then
+    LEMON_CFLAGS="$LEMON_SVNHEAD_CFLAGS"
+    LEMON_LIBS="$LEMON_SVNHEAD_LIBS"
+  else
+    LEMON_CFLAGS="$LEMON_0_5_CFLAGS"
+    LEMON_LIBS="$LEMON_0_5_LIBS"
+  fi
+  AC_SUBST(LEMON_CFLAGS)
+  AC_SUBST(LEMON_LIBS)
+fi
 
 dnl Checks for header files.
Index: design_win.cc
===================================================================
--- design_win.cc	(revision 196)
+++ design_win.cc	(revision 177)
@@ -28,9 +28,9 @@
 }
 
-DesignWin::DesignWin(const std::string& title, double attraction_v, double propulsation_v, int iterations_v)
+DesignWin::DesignWin(const std::string& title, double attraction_v, double propulsation_v, int iterations_v, NoteBookTab & mw):mytab(mw)
 {
   set_title(title);
 
-  //mytab.signal_title_ch().connect(sigc::mem_fun(*this, &DesignWin::set_title));
+  mytab.signal_title_ch().connect(sigc::mem_fun(*this, &DesignWin::set_title));
 
   signal_key_press_event().connect(sigc::mem_fun(*this, &DesignWin::closeIfEscapeIsPressed));
Index: design_win.h
===================================================================
--- design_win.h	(revision 196)
+++ design_win.h	(revision 177)
@@ -20,5 +20,8 @@
 #define DESWIN_H
 
+class DesignWin;
+
 #include <all_include.h>
+#include <nbtab.h>
 #include <libgnomecanvasmm.h>
 #include <libgnomecanvasmm/polygon.h>
@@ -27,4 +30,7 @@
 {
 private:
+  ///\ref NoteBookTab to that the \ref MapWin belongs to.
+  NoteBookTab & mytab;
+
   Gtk::SpinButton * attraction;
   Gtk::SpinButton * propulsation;
@@ -50,5 +56,5 @@
 
   ///It builds the window.
-  DesignWin(const std::string&, double, double, int);
+  DesignWin(const std::string&, double, double, int, NoteBookTab & mw);
 
   sigc::signal<void, double> signal_attraction(){return signal_attraction_ch;};
Index: dijkstrabox.cc
===================================================================
--- dijkstrabox.cc	(revision 201)
+++ dijkstrabox.cc	(revision 188)
@@ -17,9 +17,5 @@
  */
 
-#include <mapstorage.h>
-#include <mapselector.h>
-#include <algobox.h>
 #include <dijkstrabox.h>
-
 #include <lemon/dijkstra.h>
 #include <lemon/suurballe.h>
@@ -51,67 +47,4 @@
     
 void DijkstraBox::run()
-{
-  if(
-      tabcbt.get_active_text()!="" &&
-      (edgemapcbts[INPUT])->get_active_text()!="" &&
-      (edgemapcbts[OUTPUT])->get_active_text()!="" &&
-      source.get_active_text()!="" &&
-      target.get_active_text()!=""
-    )
-  {
-    const Graph &g=mapstorage->graph;
-    Node from, to;
-
-    get_from_to(from, to, (Graph&)g);
-
-    std::ostringstream o;
-
-    if(!(from==to))
-    {
-      std::string inputmapName = edgemapcbts[INPUT]->get_active_text();
-      std::string outputmapName = edgemapcbts[OUTPUT]->get_active_text();
-
-      MapStorage::NumericEdgeMap& inputmap = mapstorage->getNumericEdgeMap(inputmapName);
-      MapStorage::NumericEdgeMap& outputmap = mapstorage->getNumericEdgeMap(outputmapName);
-
-      //zero out output map
-      for (EdgeIt i(g); i!=INVALID; ++i)
-      {
-        outputmap[i]=0;
-      }
-
-      Dijkstra<Graph, MapStorage::NumericEdgeMap > dijkstra(g, inputmap);
-      dijkstra.run(from, to);
-
-      if(dijkstra.reached(to))
-      {
-        Node n=to;
-        int length=0;
-        while (n!=INVALID && n!=from)
-        {
-          Edge e=dijkstra.predEdge(n);
-          outputmap[e]=1;
-          n=dijkstra.predNode(n);
-          length++;
-        }
-        o << "Result: " << length << " long path, with cost " << dijkstra.dist(to);
-      }
-      else
-      {
-        o << "Result: failed to find shortest path between ";
-        o << source.get_active_text() << " and " << target.get_active_text();
-      }
-      resultlabel.set_text(o.str());
-
-      mapstorage->mapChanged(true, (edgemapcbts[OUTPUT])->get_active_text());
-      //   mapstorage->changeActiveMap(true, E_COLOR,
-      // 			      (edgemapcbts[OUTPUT])->get_active_text());
-      //   mapstorage->changeActiveMap(true, E_TEXT,
-      // 			      (edgemapcbts[INPUT])->get_active_text());
-    }
-  }
-}
-
-void SuurballeBox::run()
 {
   if(
@@ -132,16 +65,78 @@
       if(!(from==to))
 	{
-          MapStorage::NumericEdgeMap& inputmap=
-	    mapstorage->getNumericEdgeMap(edgemapcbts[INPUT]->get_active_text());
-          MapStorage::NumericEdgeMap& outputmap=
-	    mapstorage->getNumericEdgeMap(edgemapcbts[OUTPUT]->get_active_text());
+	  Graph::EdgeMap<double> * inputmap=
+	    (mapstorage->edgemap_storage)[(edgemapcbts[INPUT])->get_active_text()];
+	  Graph::EdgeMap<double> * outputmap=
+	    (mapstorage->edgemap_storage)[(edgemapcbts[OUTPUT])->get_active_text()];
 
 	  //zero out output map
 	  for (EdgeIt i(g); i!=INVALID; ++i)
 	    {
-	      outputmap[i]=0;
-	    }
-	  
-	  Suurballe<Graph, MapStorage::NumericEdgeMap > sb((Graph&)g, inputmap, from, to);
+	      (*outputmap)[i]=0;
+	    }
+	  
+	  Dijkstra<Graph, Graph::EdgeMap<double> > dijkstra(g, *inputmap);
+	  dijkstra.run(from, to);
+	  
+	  if(dijkstra.reached(to))
+	    {
+	      Node n=to;
+	      int length=0;
+	      while (n!=INVALID && n!=from)
+		{
+		  Edge e=dijkstra.predEdge(n);
+		  (*outputmap)[e]=1;
+		  n=dijkstra.predNode(n);
+		  length++;
+		}
+	      o << "Result: " << length << " long path, with cost " << dijkstra.dist(to);
+	    }
+	  else
+	    {
+	      o << "Result: failed to find shortest path between ";
+	      o << source.get_active_text() << " and " << target.get_active_text();
+	    }
+	  resultlabel.set_text(o.str());
+	  
+	  mapstorage->mapChanged(true, (edgemapcbts[OUTPUT])->get_active_text());
+	  //   mapstorage->changeActiveMap(true, E_COLOR,
+	  // 			      (edgemapcbts[OUTPUT])->get_active_text());
+	  //   mapstorage->changeActiveMap(true, E_TEXT,
+	  // 			      (edgemapcbts[INPUT])->get_active_text());
+	}
+    }
+}
+
+void SuurballeBox::run()
+{
+  if(
+     tabcbt.get_active_text()!="" &&
+     (edgemapcbts[INPUT])->get_active_text()!="" &&
+     (edgemapcbts[OUTPUT])->get_active_text()!="" &&
+     source.get_active_text()!="" &&
+     target.get_active_text()!=""
+     )
+    {
+      const Graph &g=mapstorage->graph;
+      Node from, to;
+
+      get_from_to(from, to, (Graph&)g);
+
+      std::ostringstream o;
+
+      if(!(from==to))
+	{
+	  Graph::EdgeMap<double> * inputmap=
+	    (mapstorage->edgemap_storage)[(edgemapcbts[INPUT])->get_active_text()];
+	  Graph::EdgeMap<double> * outputmap=
+	    (mapstorage->edgemap_storage)[(edgemapcbts[OUTPUT])->get_active_text()];
+
+	  //zero out output map
+	  for (EdgeIt i(g); i!=INVALID; ++i)
+	    {
+	      (*outputmap)[i]=0;
+	    }
+	  
+	  Suurballe<Graph, Graph::EdgeMap<double> > sb((Graph&)g, *inputmap, from, to);
 	  
 	  int found=sb.run(num_set->get_value_as_int());
@@ -154,5 +149,5 @@
 		  for(int k=0;k<path.length();k++)
 		    {
-		      outputmap[path.nth(k)]=j+1;
+		      (*outputmap)[path.nth(k)]=j+1;
 		    }
 		}
@@ -182,6 +177,6 @@
   signal_upon_maplist_updated().connect(sigc::mem_fun(*this, &DijkstraBox::maplists_updated));
 
-  addMapSelector("Cost map: ", true, NUM);
-  addMapSelector("Edges of path here: ", true, NUM);
+  addMapSelector("Cost map: ", true);
+  addMapSelector("Edges of path here: ", true);
 
   Gtk::Label * source_label=new Gtk::Label("Source: ");
@@ -214,5 +209,5 @@
 	{
 	  std::ostringstream text;
-	  text << mapstorage->getLabel(i);
+	  text << (*((mapstorage->nodemap_storage)["label"]))[i];
 	  source.prepend_text(text.str());
 	  target.prepend_text(text.str());
@@ -227,5 +222,5 @@
     {
       std::ostringstream text;
-      text << mapstorage->getLabel(i);
+      text << (*((mapstorage->nodemap_storage)["label"]))[i];
       if(!(text.str().compare(source.get_active_text())))
 	{
Index: dijkstrabox.h
===================================================================
--- dijkstrabox.h	(revision 194)
+++ dijkstrabox.h	(revision 174)
@@ -20,7 +20,8 @@
 #define DIJKSTRABOX_H
 
-class AlgoBox;
+class DijkstraBox;
 
 #include <all_include.h>
+#include <algobox.h>
 #include <libgnomecanvasmm.h>
 #include <libgnomecanvasmm/polygon.h>
Index: gdc-broken_edge.cc
===================================================================
--- gdc-broken_edge.cc	(revision 201)
+++ gdc-broken_edge.cc	(revision 174)
@@ -17,7 +17,5 @@
  */
 
-#include <graph_displayer_canvas.h>
-#include <mapstorage.h>
-#include <nbtab.h>
+#include "graph_displayer_canvas.h"
 #include <cmath>
 
@@ -36,6 +34,6 @@
 void GraphDisplayerCanvas::EdgeBase::drawArrow(XY unit_vector_in_dir)
 {
-  MapStorage& ms = *canvas.mytab.mapstorage;
-  XY center(ms.getArrowCoords(edge));
+  MapStorage& ms = canvas.mytab.mapstorage;
+  XY center(ms.arrow_pos[edge]);
   XY unit_norm_vector(0-unit_vector_in_dir.y, unit_vector_in_dir.x);
 
@@ -87,17 +85,14 @@
 void GraphDisplayerCanvas::BrokenEdge::draw()
 {
-  MapStorage& ms = *canvas.mytab.mapstorage;
+  MapStorage& ms = canvas.mytab.mapstorage;
 
   //calculating coordinates of the direction indicator arrow
-  XY head(ms.getNodeCoords(ms.graph.target(edge)));
-  XY center(ms.getArrowCoords(edge));
+  XY head(ms.coords[ms.graph.target(edge)]);
+  XY center(ms.arrow_pos[edge]);
 
   XY unit_vector_in_dir(head-center);
   double length=sqrt( unit_vector_in_dir.normSquare() );
 
-  if(length!=0)
-    {
-      unit_vector_in_dir/=length;
-    }
+  unit_vector_in_dir/=length;
 
   // update the arrow
@@ -108,10 +103,10 @@
   Node source = ms.graph.source(edge);
   Node target = ms.graph.target(edge);
-  points.push_back(Gnome::Art::Point(ms.getNodeCoords(source).x,
-        ms.getNodeCoords(source).y));
-  points.push_back(Gnome::Art::Point(ms.getArrowCoords(edge).x,
-        ms.getArrowCoords(edge).y));
-  points.push_back(Gnome::Art::Point(ms.getNodeCoords(target).x,
-        ms.getNodeCoords(target).y));
+  points.push_back(Gnome::Art::Point(ms.coords[source].x,
+        ms.coords[source].y));
+  points.push_back(Gnome::Art::Point(ms.arrow_pos[edge].x,
+        ms.arrow_pos[edge].y));
+  points.push_back(Gnome::Art::Point(ms.coords[target].x,
+        ms.coords[target].y));
   line.property_points().set_value(points);
 }
@@ -153,8 +148,8 @@
         Gnome::Canvas::Points points_new;
 
-        canvas.mytab.mapstorage->setArrowCoords(edge, canvas.mytab.mapstorage->getArrowCoords(edge) + XY(dx, dy));
+        canvas.mytab.mapstorage.arrow_pos.set(edge, canvas.mytab.mapstorage.arrow_pos[edge] + XY(dx, dy));
 
         draw();
-        canvas.textReposition(canvas.mytab.mapstorage->getArrowCoords(edge));
+        canvas.textReposition(canvas.mytab.mapstorage.arrow_pos[edge]);
 
         clicked_x=e->motion.x;
@@ -197,10 +192,10 @@
 void GraphDisplayerCanvas::LoopEdge::draw()
 {
-  MapStorage& ms = *canvas.mytab.mapstorage;
+  MapStorage& ms = canvas.mytab.mapstorage;
 
   Node node = ms.graph.source(edge);
-  XY center = (ms.getNodeCoords(node) + ms.getArrowCoords(edge)) / 2.0;
-
-  XY unit_vector_in_dir(rot90(center - ms.getArrowCoords(edge)));
+  XY center = (ms.coords[node] + ms.arrow_pos[edge]) / 2.0;
+
+  XY unit_vector_in_dir(rot90(center - ms.arrow_pos[edge]));
   double length = sqrt(unit_vector_in_dir.normSquare());
   unit_vector_in_dir /= length;
@@ -209,5 +204,5 @@
 
   double radius =
-    sqrt((ms.getArrowCoords(edge) - ms.getNodeCoords(node)).normSquare()) / 2.0;
+    sqrt((ms.arrow_pos[edge] - ms.coords[node]).normSquare()) / 2.0;
 
   XY p1 = center + XY(-radius,  radius);
@@ -250,8 +245,8 @@
       if(isbutton)
       {
-        canvas.mytab.mapstorage->setArrowCoords(edge, XY(e->motion.x, e->motion.y));
+        canvas.mytab.mapstorage.arrow_pos.set(edge, XY(e->motion.x, e->motion.y));
 
         draw();
-        canvas.textReposition(canvas.mytab.mapstorage->getArrowCoords(edge));
+        canvas.textReposition(canvas.mytab.mapstorage.arrow_pos[edge]);
       }
     default: break;
Index: graph-displayer.cc
===================================================================
--- graph-displayer.cc	(revision 201)
+++ graph-displayer.cc	(revision 174)
@@ -22,4 +22,5 @@
 
 #include "all_include.h"
+#include "mapstorage.h"
 #include "main_win.h"
 #include <libgnomecanvasmm.h>
@@ -96,13 +97,13 @@
 //     }
   if(argc>=2)
-  {
-    for(int i=1;i<argc;i++)
     {
-      if(Glib::file_test(argv[i], Glib::FILE_TEST_IS_REGULAR))
-      {
-        mytab.readFile(argv[i]);
-      }
+      for(int i=1;i<argc;i++)
+	{
+	  if(Glib::file_test(argv[i], Glib::FILE_TEST_IS_REGULAR))
+	    {
+	      mytab.readFile(argv[i]);
+	    }
+	}
     }
-  }
   else
     {
Index: graph_displayer_canvas-edge.cc
===================================================================
--- graph_displayer_canvas-edge.cc	(revision 201)
+++ graph_displayer_canvas-edge.cc	(revision 179)
@@ -17,7 +17,5 @@
  */
 
-#include <graph_displayer_canvas.h>
-#include <mapstorage.h>
-#include <nbtab.h>
+#include "graph_displayer_canvas.h"
 #include <cmath>
 
@@ -26,41 +24,40 @@
 int GraphDisplayerCanvas::resetEdgeWidth (Edge edge)
 {
-  MapStorage& ms = *mytab.mapstorage;
   double min, max;
 
   min=edge_property_defaults[E_WIDTH];
   max=edge_property_defaults[E_WIDTH];
-  Graph::EdgeMap<double> actual_map(ms.graph,edge_property_defaults[E_WIDTH]);
-
-  if(edge==INVALID)
-  {
-    for (EdgeIt i(ms.graph); i!=INVALID; ++i)
-    {
-      double v=fabs(actual_map[i]);
-      int w;
-      if(min==max)
-      {
-        w=(int)(edge_property_defaults[E_WIDTH]);
-      }
-      else
-      {
-        w=(int)(MIN_EDGE_WIDTH+(v-min)/(max-min)*(MAX_EDGE_WIDTH-MIN_EDGE_WIDTH));
-      }
-      if(zoomtrack)
-      {
-        double actual_ppu=get_pixels_per_unit();
-        w=(int)(w/actual_ppu*fixed_zoom_factor);
-      }
-      edgesmap[i]->setLineWidth(w);
-    }
-  }
-  else
-  {
-    int w=(int)actual_map[edge];
-    if(w>=0)
-    {
-      edgesmap[edge]->setLineWidth(w);
-    }
-  }
+  Graph::EdgeMap<double> actual_map((mytab.mapstorage).graph,edge_property_defaults[E_WIDTH]);
+  
+  if(edge==INVALID)
+    {
+      for (EdgeIt i((mytab.mapstorage).graph); i!=INVALID; ++i)
+	{
+	  double v=fabs(actual_map[i]);
+	  int w;
+	  if(min==max)
+	    {
+	      w=(int)(edge_property_defaults[E_WIDTH]);
+	    }
+	  else
+	    {
+	      w=(int)(MIN_EDGE_WIDTH+(v-min)/(max-min)*(MAX_EDGE_WIDTH-MIN_EDGE_WIDTH));
+	    }
+	  if(zoomtrack)
+	    {
+	      double actual_ppu=get_pixels_per_unit();
+	      w=(int)(w/actual_ppu*fixed_zoom_factor);
+	    }
+	  edgesmap[i]->setLineWidth(w);
+	}
+    }
+  else
+    {
+      int w=(int)actual_map[edge];
+      if(w>=0)
+	{
+	  edgesmap[edge]->setLineWidth(w);
+	}
+    }
   return 0;
 }
@@ -69,68 +66,60 @@
 int GraphDisplayerCanvas::changeEdgeWidth (std::string mapname, Edge edge)
 {
-  MapStorage& ms = *mytab.mapstorage;
+  Graph::EdgeMap<double> * actual_map;
   double min, max;
 
-  {
-    EdgeIt e(ms.graph);
-    min = max = ms.get(mapname, e);
-    for (; e != INVALID; ++e)
-    {
-      if (static_cast<double>(ms.get(mapname, e)) > max)
-        max = ms.get(mapname, e);
-      if (static_cast<double>(ms.get(mapname, e)) < min)
-        min = ms.get(mapname, e);
-    }
-  }
-
-  if(edge==INVALID)
-  {
-    for (EdgeIt i(ms.graph); i!=INVALID; ++i)
-    {
-      double v=ms.get(mapname, i);
-      int w;
-      if(autoscale)
-      {
-        if(min==max)
-        {
-          w=(int)(edge_property_defaults[E_WIDTH]);
-        }
-        else
-        {
-          w=(int)(minimum_edge_width+(v-min)/(max-min)*(edge_width-minimum_edge_width));
-        }
-      }
-      else
-      {
-        w=(int)(v*edge_width);
-      }
-      if(w<0)
-      {
-        edgesmap[i]->hide();
-      }
-      else
-      {
-        edgesmap[i]->show();
-        if(w<minimum_edge_width)
-        {
-          w=minimum_edge_width;
-        }
-        if(zoomtrack)
-        {
-          double actual_ppu=get_pixels_per_unit();
-          w=(int)(w/actual_ppu*fixed_zoom_factor);
-        }
-        edgesmap[i]->setLineWidth(w);
-      }
-    }
-  }
-  else
-  {
-    int w=(int)ms.get(mapname, edge);
-    if(w>=0)
-    {
-      edgesmap[edge]->setLineWidth(w);
-    }
-  }
+  min=(mytab.mapstorage).minOfEdgeMap(mapname);
+  max=(mytab.mapstorage).maxOfEdgeMap(mapname);
+  actual_map=((mytab.mapstorage).edgemap_storage)[mapname];
+
+  if(edge==INVALID)
+    {
+      for (EdgeIt i((mytab.mapstorage).graph); i!=INVALID; ++i)
+	{
+	  double v=(*actual_map)[i];
+	  int w;
+	  if(autoscale)
+	    {
+	      if(min==max)
+		{
+		  w=(int)(edge_property_defaults[E_WIDTH]);
+		}
+	      else
+		{
+		  w=(int)(minimum_edge_width+(v-min)/(max-min)*(edge_width-minimum_edge_width));
+		}
+	    }
+	  else
+	    {
+	      w=(int)(v*edge_width);
+	    }
+	  if(w<0)
+	    {
+	      edgesmap[i]->hide();
+	    }
+	  else
+	    {
+	      edgesmap[i]->show();
+	      if(w<minimum_edge_width)
+		{
+		  w=minimum_edge_width;
+		}
+	      if(zoomtrack)
+		{
+		  double actual_ppu=get_pixels_per_unit();
+		  w=(int)(w/actual_ppu*fixed_zoom_factor);
+		}
+	      edgesmap[i]->setLineWidth(w);
+	    }
+	}
+    }
+  else
+    {
+      int w=(int)(*actual_map)[edge];
+      if(w>=0)
+	{
+	  edgesmap[edge]->setLineWidth(w);
+	}
+    }
   return 0;
 };
@@ -138,29 +127,21 @@
 int GraphDisplayerCanvas::changeEdgeColor (std::string mapname, Edge edge)
 {  
-  MapStorage& ms = *mytab.mapstorage;
 
   //function maps the range of the maximum and
   //the minimum of the nodemap to the range of
   //green in RGB
+  Graph::EdgeMap<double> * actual_map;
+  actual_map=((mytab.mapstorage).edgemap_storage)[mapname];
 
   double max, min;
 
-  {
-    EdgeIt e(ms.graph);
-    min = max = ms.get(mapname, e);
-    for (; e != INVALID; ++e)
-    {
-      if (static_cast<double>(ms.get(mapname, e)) > max)
-        max = ms.get(mapname, e);
-      if (static_cast<double>(ms.get(mapname, e)) < min)
-        min = ms.get(mapname, e);
-    }
-  }
-
-  if(edge==INVALID)
-    {
-      for (EdgeIt i(ms.graph); i!=INVALID; ++i)
-	{
-	  double w=ms.get(mapname, i);
+  max=(mytab.mapstorage).maxOfEdgeMap(mapname);
+  min=(mytab.mapstorage).minOfEdgeMap(mapname);
+
+  if(edge==INVALID)
+    {
+      for (EdgeIt i((mytab.mapstorage).graph); i!=INVALID; ++i)
+	{
+	  double w=(*actual_map)[i];
 
 	  Gdk::Color color;
@@ -180,5 +161,5 @@
       Gdk::Color color;
 
-      double w=ms.get(mapname, edge);
+      double w=(*actual_map)[edge];
 
       if(max!=min)
@@ -198,10 +179,9 @@
 int GraphDisplayerCanvas::resetEdgeColor (Edge edge)
 {  
-  MapStorage& ms = *mytab.mapstorage;
 
   //function maps the range of the maximum and
   //the minimum of the nodemap to the range of
   //green in RGB
-  Graph::EdgeMap<double> actual_map(ms.graph,edge_property_defaults[E_COLOR]);
+  Graph::EdgeMap<double> actual_map((mytab.mapstorage).graph,edge_property_defaults[E_COLOR]);
 
   double max, min;
@@ -211,38 +191,38 @@
 
   if(edge==INVALID)
-  {
-    for (EdgeIt i(ms.graph); i!=INVALID; ++i)
-    {
-      double w=actual_map[i];
-
+    {
+      for (EdgeIt i((mytab.mapstorage).graph); i!=INVALID; ++i)
+	{
+	  double w=actual_map[i];
+
+	  Gdk::Color color;
+	  if(max!=min)
+	    {
+	      color.set_rgb_p (0, 100*(w-min)/(max-min), 0);
+	    }
+	  else
+	    {
+	      color.set_rgb_p (0, 100, 0);
+	    }
+	  edgesmap[i]->setFillColor(color);
+	}
+    }
+  else
+    {
       Gdk::Color color;
+
+      double w=actual_map[edge];
+
       if(max!=min)
-      {
-        color.set_rgb_p (0, 100*(w-min)/(max-min), 0);
-      }
+	{
+	  color.set_rgb_p (0, 100*(w-min)/(max-min), 0);
+	}
       else
-      {
-        color.set_rgb_p (0, 100, 0);
-      }
-      edgesmap[i]->setFillColor(color);
-    }
-  }
-  else
-  {
-    Gdk::Color color;
-
-    double w=actual_map[edge];
-
-    if(max!=min)
-    {
-      color.set_rgb_p (0, 100*(w-min)/(max-min), 0);
-    }
-    else
-    {
-      color.set_rgb_p (0, 100, 0);
-    }
-
-    edgesmap[edge]->setFillColor(color);
-  }
+	{
+	  color.set_rgb_p (0, 100, 0);
+	}
+
+      edgesmap[edge]->setFillColor(color);
+    }
   return 0;
 };
@@ -250,53 +230,59 @@
 int GraphDisplayerCanvas::changeEdgeText (std::string mapname, Edge edge)
 {
-  MapStorage& ms = *mytab.mapstorage;
-
   //the number in the map will be written on the edge
   //EXCEPT when the name of the map is Default, because
   //in that case empty string will be written, because
   //that is the deleter map
-
-  if(edge==INVALID)
-  {
-    for (EdgeIt i(ms.graph); i!=INVALID; ++i)
-    {
-      edgemap_to_edit=mapname;
-
-      edgetextmap[i]->property_text().set_value(
-          static_cast<std::string>(ms.get(mapname, i)));
-    }
-
-  }
-  else
-  {
-    edgetextmap[edge]->property_text().set_value(
-        static_cast<std::string>(ms.get(mapname, edge)));
-  }
-
-  return 0;
+  
+  if(edge==INVALID)
+    {
+      for (EdgeIt i((mytab.mapstorage).graph); i!=INVALID; ++i)
+	{
+	  edgemap_to_edit=mapname;
+	  double number=(*((mytab.mapstorage).edgemap_storage)[mapname])[i];
+	  
+	  std::ostringstream ostr;
+	  ostr << number;
+	  
+	  edgetextmap[i]->property_text().set_value(ostr.str());
+	}
+
+    }
+  else
+    {
+	  double number=(*((mytab.mapstorage).edgemap_storage)[mapname])[edge];
+
+	  std::ostringstream ostr;
+	  ostr << number;
+	  
+	  edgetextmap[edge]->property_text().set_value(ostr.str());
+    }
+
+  return 0;
+
 };
 
 int GraphDisplayerCanvas::resetEdgeText (Edge edge)
 {
-  MapStorage& ms = *mytab.mapstorage;
-
   //the number in the map will be written on the edge
   //EXCEPT when the name of the map is Default, because
   //in that case empty string will be written, because
   //that is the deleter map
-
-  if(edge==INVALID)
-  {
-    for (EdgeIt i(ms.graph); i!=INVALID; ++i)
-    {
-      edgemap_to_edit="";
-      edgetextmap[i]->property_text().set_value("");
-    }
-  }
-  else
-  {
-    edgetextmap[edge]->property_text().set_value("");
-  }
-
-  return 0;
-};
+  
+  if(edge==INVALID)
+    {
+      for (EdgeIt i((mytab.mapstorage).graph); i!=INVALID; ++i)
+	{
+	  edgemap_to_edit="";
+	  edgetextmap[i]->property_text().set_value("");
+	}
+
+    }
+  else
+    {
+      edgetextmap[edge]->property_text().set_value("");
+    }
+
+  return 0;
+
+};
